package it.eng.spago.base;

import it.eng.spago.util.XMLUtil;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class NullValue implements XMLObject {
	
	private static final String NULL_VALUE = "null";
	private static final String NULL_VALUE_ELEMENT = "NULL";

	public Document toDocument() {
		return toDocument(null);
	}

	public Document toDocument(XMLSerializer serializer) {
        return XMLUtil.toDocument(this, serializer);
	}

	public Element toElement(Document document) {
        return toElement(document, null);
	}

	public Element toElement(Document document, XMLSerializer serializer) {
		return document.createElement(NULL_VALUE_ELEMENT);
	}

	public String toXML() {
		return NULL_VALUE;
	}

	public String toXML(boolean inlineEntity) {
		return NULL_VALUE;
	}

	public String toXML(int level) {
		return NULL_VALUE;
	}

}
