/**

    Copyright 2004, 2006 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.base;

/**
 * La classe <code>SourceBeanException</code> implementa un eccezione generica
 * lanciata in conseguenza di errori nei servizi degli oggetti
 * <code>SourceBeanAttribute</code> e <code>SourceBean</code>.
 * @version 1.0, 11/03/2002
 * @author Luigi Bellio
 * @see SourceBeanAttribute
 * @see SourceBean
 */
public class SourceBeanException extends Exception {
    /**
     * 
     */
    private static final long serialVersionUID = 1L;

    /**
     * Costruisce ed inizializza l'eccezione.
     */
    public SourceBeanException(String message) {
        if (message == null)
            _message = "NOT DEFINED";
        else
            _message = message;
    } // public SourceBeanException(String message)

    /**
     * Ritorna il messaggio associato all'eccezione.
     */
    public String getMessage() {
        return _message;
    } // public String getMessage()

    /**
     * Messaggio associato all'eccezione.
     */
    private String _message = null;
} // public class SourceBeanException extends Exception
