package it.eng.spago.base;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * This is the interface to implement by objects that serialize from Java object to XML
 */
public interface XMLSerializer {
    
    /**
     * Serialize the object source putting in the DOM document.
     * @param document Current DOM
     * @param element Current element in DOM
     * @param key Key of the object to serialize
     * @param source Object to serialize
     */
    void serialize(Document document, Element element, final String key, final Object source);

}
