/**

    Copyright 2004, 2006 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.cache;

import it.eng.spago.base.ApplicationContainer;
import it.eng.spago.base.Constants;
import it.eng.spago.base.SourceBean;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.init.InitializerIFace;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * This spago initializers built a simple list of the services that are reachable from
 * other services and put in Application container
 *
 * @author Andrea Zoppello
 */
public class CacheResponseInitializer implements InitializerIFace {
    private SourceBean _config = null;

    public CacheResponseInitializer() {
        super();
        _config = null;
    } // public DataAccessInitializer()

    public void init(SourceBean config) {
       
    	ApplicationContainer application = ApplicationContainer.getInstance();
    	
    	List globalReachedServices = new ArrayList();
    	ConfigSingleton configure = ConfigSingleton.getInstance();
    	
    	List actions = configure.getAttributeAsList(Constants.ACTION_PATH);
    	
    	SourceBean serviceSB = null;
    	List listReachedServiceList  = null;
    	SourceBean reachServiceSb  = null;
    	Iterator it = actions.iterator();
    	
    	while (it.hasNext()){
    		serviceSB = (SourceBean)it.next();
    		listReachedServiceList = serviceSB.getAttributeAsList("REACH-SERVICES.TARGET-SERVICE");
    		
    			for (int i=0; i < listReachedServiceList.size(); i++){
    				reachServiceSb = (SourceBean)listReachedServiceList.get(i);
    				globalReachedServices.add(reachServiceSb.getCharacters());
    			}
    		
    	}
    	
    	
    	
    	List pages = configure.getAttributeAsList(Constants.PAGE_PATH);
    	it = pages.iterator();
    	
    	while (it.hasNext()){
    			serviceSB = (SourceBean)it.next();
    			listReachedServiceList = serviceSB.getAttributeAsList("REACH-SERVICES.TARGET-SERVICE");
    		
    			for (int i=0; i < listReachedServiceList.size(); i++){
    				reachServiceSb = (SourceBean)listReachedServiceList.get(i);
    				globalReachedServices.add(reachServiceSb.getCharacters());
    			}
		}
    	
		application.setAttribute("REACHABLE_LIST",globalReachedServices);
    	
    	
    } // public void init(SourceBean config)

    public SourceBean getConfig() {
        return _config;
    } // public SourceBean getConfig()
} // public class DataAccessInitializer implements InitializerIFace
