/**

    Copyright 2004, 2006 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.dbaccess.hibernate;

import net.sf.hibernate.HibernateException;
import net.sf.hibernate.cfg.Configuration;

import it.eng.spago.base.Constants;
import it.eng.spago.base.SourceBean;
import it.eng.spago.init.InitializerIFace;
import it.eng.spago.tracing.TracerSingleton;

public class HibernateInitializer implements InitializerIFace {
    private SourceBean _config = null;

    /** @link dependency 
     * @stereotype use*/
    /*# HibernateSessionFactory lnkHibernateSessionFactory; */

    public HibernateInitializer() {
        super();
    } // public HibernateInitializer()

    public void init(SourceBean config) {
        TracerSingleton.log(
            Constants.NOME_MODULO,
            TracerSingleton.DEBUG,
            "HibernateInitializer::init: config",
            config);
        _config = config;
        try {
            Configuration conf = new Configuration();
            conf.configure();
            //new SchemaUpdate(conf).execute(true, true);
            HibernateSessionFactory.setSessionFactory(
                conf.buildSessionFactory());
        } // try
        catch (HibernateException ex) {
            ex.printStackTrace();
            throw new RuntimeException(
                "Exception building SessionFactory: " + ex.getMessage());
        } // catch (HibernateException ex)
    } // public void init(SourceBean config)

    public SourceBean getConfig() {
        return _config;
    } // public SourceBean getConfig()
} // public class HibernateInitializer implements InitializerIFace
