/**

    Copyright 2004, 2006 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
/* Generated by Together */

package it.eng.spago.dbaccess.sql.result;

import java.sql.ResultSet;
import java.util.List;

import it.eng.spago.dbaccess.sql.DataField;
import it.eng.spago.dbaccess.sql.SQLCommand;
import it.eng.spago.error.EMFInternalError;

/**
* Questa Classe rappresenta una factory astratta per la creazione di oggetti di tipo DataResultInterface
*
* @author Andrea Zoppello 
* @version 1.0
*/
public interface DataResultFactory {
    /**
    * Crea un oggetto DataResultInterface di tipo ScrollableDataResult
    * @param <B>SQLCommand</B> command - Il comando che ha generato come risultato l'oggetto ScrollableDataResult che verr creato da questa funzione
    * @param <B>List</B> inputParameters - La lista dei parametri di input del comando che ha generato come risultato l'oggetto ScrollableDataResult che verr creato da questa funzione
    * @param <B>ResultSet</B> rs - Il ResultSet alla base dell'oggetto ScrollableDataResult creato da questa funzione
    * @return un oggetto di tipo <B>DataResultInterface</B> - che in realt  di tipo ScrollableDataResult
    * @throws <B>EMFInternalError</B> - Se qualche errore si verifica nella creazione dell'oggetto fi tipo ScrollableDataResult
    */
    public DataResultInterface createScrollableDataResult(SQLCommand command, List inputParameters, ResultSet rs, boolean std)
        throws EMFInternalError;

    /**
    * Crea un oggetto DataResultInterface di tipo PunctualDataResult
    * @param <B>SQLCommand</B> command - Il comando che ha generato come risultato l'oggetto PunctualDataResult che verr creato da questa funzione
    * @param <B>List</B> inputParameters - La lista dei parametri di input del comando che ha generato come risultato l'oggetto PunctualDataResult che verr creato da questa funzione
    * @param <B>DataField</B> punctualData - Il dataField che costituice il dato puntuale alla base dell'oggetto PunctualDataResult creato da questa funzione
    * @return un oggetto di tipo <B>DataResultInterface</B> - che in realt  di tipo PunctualDataResult
    * @throws <B>EMFInternalError</B> - Se qualche errore si verifica nella creazione dell'oggetto fi tipo PunctualDataResult
    */
    public DataResultInterface createPunctualDataResult(SQLCommand command, List inputParameters, DataField punctualData)
        throws EMFInternalError;

    /**
    * Crea un oggetto DataResultInterface di tipo InformationDataResult
    * @param <B>SQLCommand</B> command - Il comando che ha generato come risultato l'oggetto InformationDataResult che verr creato da questa funzione
    * @param <B>List</B> inputParameters - La lista dei parametri di input del comando che ha generato come risultato l'oggetto InformationDataResult che verr creato da questa funzione
    * @param boolean correctExecution - true se l'esecuzione del comando  avvenuta correttamente
    * @param int rowsAffected - il numero di righe coinvolte nll'esecuzione del comando
    * @param String executionMessage - eventuale messaggio dell'InformationDataResult da creare
    * @return un oggetto di tipo <B>DataResultInterface</B> - che in realt  di tipo InformationDataResult
    * @throws <B>EMFInternalError</B> - Se qualche errore si verifica nella creazione dell'oggetto fi tipo InformationDataResult
    */
    public DataResultInterface createInformationDataResult(
        SQLCommand command,
        List inputParameters,
        boolean correctExecution,
        int rowsAffected,
        String executionMessage)
        throws EMFInternalError;

    /**
    * Crea un oggetto DataResultInterface di tipo InformationDataResult
    * @param <B>SQLCommand</B> command - Il comando che ha generato come risultato l'oggetto CompositeDataResult che verr creato da questa funzione
    * @param <B>List</B> inputParameters - La lista dei parametri di input del comando che ha generato come risultato l'oggetto CompositeDataResult che verr creato da questa funzione
    * @return un oggetto di tipo <B>DataResultInterface</B> - che in realt  di tipo CompositeDataResult
    * @throws <B>EMFInternalError</B> - Se qualche errore si verifica nella creazione dell'oggetto fi tipo CompositeDataResult
    */
    public DataResultInterface createCompositeDataResult(SQLCommand command, List inputParameters) throws EMFInternalError;
} //end Interface DataResultFactory
