/**

    Copyright 2004, 2006 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.dbaccess.test;

import it.eng.spago.base.SourceBean;
import it.eng.spago.dbaccess.DataConnectionManager;
import it.eng.spago.dbaccess.sql.DataConnection;
import it.eng.spago.dbaccess.sql.DataRow;
import it.eng.spago.dbaccess.sql.SQLCommand;
import it.eng.spago.dbaccess.sql.result.DataResult;
import it.eng.spago.dbaccess.sql.result.ScrollableDataResult;
import it.eng.spago.error.EMFInternalError;

import java.sql.Types;
import java.util.ArrayList;
import java.util.List;

public class TestGetConnectio {
    public static String queryString = "select banca.cod_abiswift ABI ," + "banca.desc_ragsoc DENOMINAZIONE_BANCA," +
        "sportello.cod_cabswift CAB," + "rapporto.cod_rapporto CC," + "info_poe.get_desc_cc(cc.id) DESCRIZIONE_RAPPORTO," +
        "rapporto.cod_divisa DIVISA," + "s.data_saldo DATA," + "s.imp_saldo_contabile_ricevuto SALDO " +
        "FROM conto_corrente cc," + "rapporto," + "sportello," + "banca," + "utente_telematico ut," +
        "saldo_di_conto_corrente s " + "where s.conto_corrente = cc.id AND " +
        "s.data_saldo in (select max(data_saldo) from saldo_di_conto_corrente where conto_corrente = cc.id) and " +
        "UT.COD_SIA='DEMO2' AND UT.COD_PIVA=UT.COD_FISCALE AND " + "sportello.banca = banca.id and " +
        "rapporto.id = cc.id and " + "rapporto.sportello = sportello.id and " + "rapporto.utente_telematico = UT.ID and " +
        "banca.cod_abiswift = '05728' and " + "info_poe.is_expired(cc.data_estinzione) = 'N' " + "order by " +
        "rapporto.DATA_ACCENSIONE desc";
    public static String BLANK = " ";
    public static String parQuery = "select" + BLANK + "a.ID ID," + "DESCRIZIONE_RAPPORTO," + "CODICE_ABI_BANCA," +
        "CODICE_CAB_BANCA," + "CONTO_CORRENTE," + "nvl(CODICE_DIVISA, 'ITL') DIVISA," + "DATA_CONTABILE," +
        "SALDO_INIZIALE_QUADRATURA," + "SALDO_CONTABILE_FINALE," + "SALDO_LIQUIDO_FINALE," +
        "CONTROVALORE_SALDO_FINALE NUM_CONTROVALORE_SALDO_FINALE," + "DATA_LIQUIDITA_PRIMO_SALDO," + "PRIMO_SALDO_LIQUIDO," +
        "DATA_LIQUIDITA_SECONDO_SALDO," + "SECONDO_SALDO_LIQUIDO," + "DATA_LIQUIDITA_TERZO_SALDO," + "TERZO_SALDO_LIQUIDO," +
        "DATA_LIQUIDITA_QUARTO_SALDO," + "QUARTO_SALDO_LIQUIDO," + "DATA_LIQUIDITA_QUINTO_SALDO," + "QUINTO_SALDO_LIQUIDO," +
        "DE1ABI," + "COD_RAPPORTO," + "info_poe.is_expired(cc.data_estinzione) SCADUTO " + "from" + BLANK +
        "saldo_iniziale_finale_liq a," + BLANK + "rapporto b," + BLANK + "pf_abi c," + BLANK + "conto_corrente cc" + BLANK +
        "where" + BLANK + "a.CONTO_CORRENTE = ?" + BLANK + "and a.CONTO_CORRENTE = b.ID" + BLANK + "and cc.ID = b.ID" + BLANK +
        "and a.DATA_CONTABILE = (SELECT MAX(DATA_CONTABILE) FROM saldo_iniziale_finale_liq where CONTO_CORRENTE = ?)" + BLANK +
        "and CODABI (+) = a.CODICE_ABI_BANCA";

    public static void main(String[] args) {
        try {
            DataConnectionManager dcm = DataConnectionManager.getInstance();
            DataConnection dataConnection = dcm.getConnection();

            /*
            for (int i=0; i < 10; i++){
                variableQuery(dataConnection, parQuery);
            }
            */

            String strSelect = "SELECT id_licenza,nome,descrizione,versione,tipo,tipo_macchina,categoria,note,id_modifier,data_modifica FROM LICENZA WHERE DELETED=0 ORDER BY categoria";
            SQLCommand command = dataConnection.createSelectCommand(strSelect);
            // Chiamo la stored procedure
            DataResult dr = command.execute();
            ScrollableDataResult resultInterface = (ScrollableDataResult)dr.getDataObject();
            resultInterface.getRowsNumber();
            // <<<<<<<<<<<<<---------- E QUI SCOPPIA TUTTO
            while (resultInterface.hasRows()) {
                // Trasformo il DataRow in un DataBean
                DataRow row = resultInterface.getDataRow();
                //DataBean dataBean = create();
                //rowToDataBean(row, dataBean);
                //result.addElement(dataBean);
                System.out.println("-----------------");
                System.out.println(row.getSourceBean().toXML());
                System.out.println("-----------------");
            }
            dataConnection.close();
        }
        catch (EMFInternalError eie) {
            System.out.println(eie.getDescription());
        } //end try-cath
    } //end main

    public static void fixedQuery(DataConnection dc) {
        try {
            SQLCommand selectCommand = dc.createSelectCommand(queryString);
            DataResult dr = selectCommand.execute();
            if (dr.getDataResultType().equals("SCROLLABLE_DATA_RESULT")) {
                ScrollableDataResult sdr = (ScrollableDataResult)dr.getDataObject();
                System.out.println(sdr.getRowsNumber());
                // Scrollable DataResult
                while (sdr.hasRows()) {
                    DataRow row = sdr.getDataRow();
                    System.out.println((row.getColumn("ABI")).getObjectValue());
                }
                sdr.moveTo(1);
                SourceBean sourceBean = sdr.getSourceBean();
                System.out.println(sourceBean.toXML());
                System.out.println(" Eseguito comando e ottenuto result set.... continua ");
                //char c = (char)System.in.read();
                sdr.close();
                selectCommand.close();
                System.out.println(" Effettuate le close continua ");
                //c = (char)System.in.read();
            } //END IF
        }
        catch (Exception eie) {
            eie.printStackTrace();
        }
    }

    public static void variableQuery(DataConnection dc, String parametricQueryString) {
        try {
            SQLCommand selectCommand = dc.createSelectCommand(parametricQueryString);
            List inputParameters = new ArrayList(2);
            inputParameters.add(dc.createDataField("", Types.INTEGER, new Integer(4594)));
            inputParameters.add(dc.createDataField("", Types.INTEGER, new Integer(4594)));
            DataResult dr = selectCommand.execute(inputParameters);
            if (dr.getDataResultType().equals("SCROLLABLE_DATA_RESULT")) {
                ScrollableDataResult sdr = (ScrollableDataResult)dr.getDataObject();
                System.out.println(sdr.getRowsNumber());
                // Scrollable DataResult
                while (sdr.hasRows()) {
                    sdr.getDataRow();
                    //System.out.println((row.getColumn("ABI")).getObjectValue());
                }
                sdr.moveTo(1);
                SourceBean sourceBean = sdr.getSourceBean();
                System.out.println(sourceBean.toXML());
                System.out.println(" Eseguito comando e ottenuto result set.... continua ");
                //char c = (char)System.in.read();
                sdr.close();
                selectCommand.close();
                System.out.println(" Effettuate le close continua ");
                //c = (char)System.in.read();
            } //END IF
        }
        catch (Exception eie) {
            eie.printStackTrace();
        }
    } //end query
}
