/**

    Copyright 2004, 2006 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.dispatching.action;

import it.eng.spago.dispatching.service.ServiceIFace;

/**
 * La classe <code>ActionIFace</code> &egrave; l'interfaccia che viene implementata da tutti gli oggetti
 * di tipo action.
 */
public interface ActionIFace extends ServiceIFace {
    /**
     * Permette di recuperare il nome logico dell'action.
     * @return <code>String<code> il nome logico dell'action.
     */
    String getActionName();

    /**
     * Rende disponbile alla action il proprio nome logico . Questo  a carico dell' Application Framework.
     * @param action nome logico della action.
     */
    void setActionName(String action);
} // public interface ActionIFace extends ServiceIFace
