/**

    Copyright 2004, 2006 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.dispatching.action.list.smart.impl;

import it.eng.spago.base.SourceBean;
import it.eng.spago.dispatching.action.list.smart.AbstractSmartListAction;
import it.eng.spago.dispatching.service.list.smart.impl.DelegatedSmartListService;
import it.eng.spago.paginator.smart.IFaceListProvider;

public class DefaultSmartListAction extends AbstractSmartListAction {
    /**
     * 
     */
    private static final long serialVersionUID = 1L;

    public DefaultSmartListAction() {
        super();
    } // public DefaultSmartListAction()

    public void init(SourceBean config) {
        super.init(config);
        DelegatedSmartListService.init(this, config);
    } // public void init(SourceBean config)

    public IFaceListProvider getList(SourceBean request, SourceBean response) throws Exception {
        return DelegatedSmartListService.getList(this, request, response);
    } // public IFaceListProvider getList(SourceBean request, SourceBean response) throws Exception

    public boolean delete(SourceBean request, SourceBean response) {
        return DelegatedSmartListService.delete(this, request, response);
    } // public boolean delete(SourceBean request, SourceBean response)
} // public class DefaultSmartListAction extends AbstractSmartListAction
