/**

    Copyright 2004, 2006 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.dispatching.distributor;

import java.io.Serializable;

import it.eng.spago.base.SourceBean;
import it.eng.spago.dispatching.service.DefaultRequestContext;
import it.eng.spago.init.InitializerIFace;

public abstract class AbstractDistributor extends DefaultRequestContext implements InitializerIFace,
    DistributorIFace, Serializable {
        private SourceBean _config = null;
        private String _distributor = null;

        public AbstractDistributor() {
            super();
            _config = null;
            _distributor = null;
        } // public AbstractDistributor()

        public void init(SourceBean config) {
            _config = config;
        } // public void init(SourceBean config)

        public SourceBean getConfig() {
            return _config;
        } // public SourceBean getConfig()

        public String getDistributor() {
            return _distributor;
        } // public String getDistributor()

        public void setDistributor(String distributor) {
            _distributor = distributor;
        } // public void setDistributor(String distributor)
} // public abstract class AbstractDistributor extends DefaultRequestContext
// implements InitializerIFace, DistributorIFace, Serializable
