/**

    Copyright 2004, 2006 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.dispatching.module;

import it.eng.spago.base.Constants;
import it.eng.spago.base.SourceBean;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.dispatching.coordinator.CoordinatorIFace;
import it.eng.spago.dispatching.coordinator.DispatcherIFace;
import it.eng.spago.dispatching.service.RequestContextIFace;

public class ModuleDispatcher implements DispatcherIFace {
    public ModuleDispatcher() {
    } // public ModuleDispatcher()

    public boolean acceptsURL(RequestContextIFace requestContext) {
        SourceBean serviceRequest = requestContext.getRequestContainer().getServiceRequest();
        return serviceRequest.containsAttribute(Constants.PAGE);
    } // public boolean acceptsURL(RequestContextIFace requestContext)

    public String getBusinessType(RequestContextIFace requestContext) {
        return "PAGE";
    } // public String getBusinessType(RequestContextIFace requestContext)

    public String getBusinessName(RequestContextIFace requestContext) {
        SourceBean serviceRequest = requestContext.getRequestContainer().getServiceRequest();
        String pageName = (String)serviceRequest.getAttribute(Constants.PAGE);
        return pageName.toUpperCase();
    } // public String getBusinessName(RequestContextIFace requestContext)

    public String getPublisherName(RequestContextIFace requestContext) {
        ConfigSingleton configure = ConfigSingleton.getInstance();
        SourceBean actionBean = (SourceBean)configure.getFilteredSourceBeanAttribute(Constants.PAGE_PATH, "NAME", getBusinessName(requestContext));
        if (actionBean == null) {
            return null;
        }
        String publisherName = (String)actionBean.getAttribute(Constants.PUBLISHER_NAME);
        return publisherName;
    } // public String getBusinessName(RequestContextIFace requestContext)

    public CoordinatorIFace getCoordinator(RequestContextIFace requestContext) {
        return new ModuleCoordinator(getBusinessType(requestContext), getBusinessName(requestContext), getPublisherName(requestContext));
    } // public CoordinatorIFace getCoordinator(RequestContextIFace requestContext)
} // public class ModuleDispatcher implements DispatcherIFace
