/**

    Copyright 2004, 2006 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.dispatching.module.list.smart;

import it.eng.spago.base.Constants;
import it.eng.spago.base.SourceBean;
import it.eng.spago.dispatching.module.AbstractModule;
import it.eng.spago.dispatching.service.list.smart.IFaceSmartListService;
import it.eng.spago.dispatching.service.list.smart.impl.DelegatedSmartListService;
import it.eng.spago.paginator.smart.IFaceListProvider;
import it.eng.spago.tracing.TracerSingleton;

public abstract class AbstractSmartListModule extends AbstractModule implements IFaceSmartListService {
    private IFaceListProvider _list = null;

    public AbstractSmartListModule() {
        super();
    } // public AbstractSmartListModule()

    /**
     * @see it.eng.spago.dispatching.service.ServiceIFace#service(SourceBean, SourceBean)
     */
    public void service(SourceBean serviceRequest, SourceBean serviceResponse) throws Exception {
        TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.DEBUG, "AbstractSmartListModule::service: invocato");
        DelegatedSmartListService.service(this, serviceRequest, serviceResponse);
    } // public void service(SourceBean serviceRequest, SourceBean
    // serviceResponse) throws Exception

    /**
     * @see it.eng.spago.dispatching.service.list.smart.IFaceSmartListService#getList()
     */
    public IFaceListProvider getList() {
        TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.DEBUG, "AbstractSmartListModule::getList: invocato");
        return _list;
    } // public IFaceListProvider getList()

    /**
     * @see it.eng.spago.dispatching.service.list.smart.IFaceSmartListService#setList(IFaceListProvider)
     */
    public void setList(IFaceListProvider list) {
        TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.DEBUG, "AbstractSmartListModule::setList: invocato");
        _list = list;
    } // public void setList(IFaceListProvider list)

    /**
     * @see it.eng.spago.dispatching.service.list.smart.IFaceSmartListService#callback(SourceBean, IFaceListProvider, int)
     */
    public void callback(SourceBean request, SourceBean response, IFaceListProvider list, int page) throws Exception {
        TracerSingleton.log(
            Constants.NOME_MODULO,
            TracerSingleton.WARNING,
            "AbstractSmartListModule::callback: metodo non implementato !");
    } // public void callback(SourceBean request,SourceBean response,
    // IFaceListProvider list, int page) throws Exception

    /**
     * @see it.eng.spago.dispatching.service.list.smart.IFaceSmartListService#delete(SourceBean)
     */
    public boolean delete(SourceBean request, SourceBean response) {
        TracerSingleton.log(
            Constants.NOME_MODULO,
            TracerSingleton.WARNING,
            "AbstractSmartListModule::delete: metodo non implementato !");
        return false;
    } // public boolean delete(SourceBean request, SourceBean response)
} // public abstract class AbstractSmartListModule extends AbstractModule implements IFaceSmartListService
