/**

    Copyright 2004, 2006 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.dispatching.service;

import it.eng.spago.base.SourceBean;

/**
 * Questa interfaccia viene implementata da tutti gli oggetti di business .
 */
public interface ServiceIFace {
    /**
     * Questo metodo viene invocato dall'application framework per eseguire la logica di business
     * implemetata dell'oggetto stesso.
     * @param serviceRequest il <code>SourceBean</code> contenente i parametri della richiesta.
     * @param serviceResponse il <code>SourceBean</code> che dovr essere popolato con gli
     * oggetti legati alla risposta.
     */
    void service(SourceBean serviceRequest, SourceBean serviceResponse) throws Exception;
} // public interface ServiceIFace
