package it.eng.spago.message;

import java.util.Iterator;
import java.util.List;

import it.eng.spago.base.SourceBean;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.init.InitializerIFace;

public class MessageBundleInitializer implements InitializerIFace {
    private SourceBean _config = null;

    public MessageBundleInitializer() {
        super();
        _config = null;
    } // public DataAccessInitializer()

    public void init(SourceBean config) {
        _config = config;

        ConfigSingleton configuration = ConfigSingleton.getInstance();
        List bundlesNames = configuration.getAttributeAsList("MESSAGES.BUNDLE");
        for (Iterator it = bundlesNames.iterator(); it.hasNext();) {
            SourceBean sb = (SourceBean)it.next();
            String bundleName = (String)sb.getAttribute("NAME");
            MessageBundle.addBundleName(bundleName);
        }
    }

    public SourceBean getConfig() {
        return _config;
    }

}
