/**

    Copyright 2004, 2006 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.notifier;

import java.util.ArrayList;
import java.util.Iterator;

import it.eng.spago.mail.MailIFace;

public abstract class AbstractNotifier {
    public AbstractNotifier() {
        super();
    }

    public void service() {
        ArrayList notifications = getNotifications();
        Iterator notificationIterator = notifications.iterator();
        NotificationIFace notification = null;
        MailIFace mail = null;
        String toAll = null;
        while (notificationIterator.hasNext()) {
            notification = (NotificationIFace)notificationIterator.next();
            mail = notification.createMail();
            toAll = getAddresseesMail(notification.getEvent(), notification.getPlugin());
            if (!toAll.equals("")) {
                mail.setTo(toAll);
                if (mail.send())
                    confirmNotification(notification, true);
                else
                    confirmNotification(notification, false);
            }
        }
    }

    public abstract ArrayList getNotifications();

    public abstract String getAddresseesMail(String event, String plugin);

    public abstract void confirmNotification(NotificationIFace notification, boolean confirm);
}
