/**

    Copyright 2004, 2006 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.security;

import javax.crypto.Cipher;
import javax.crypto.spec.SecretKeySpec;

import org.apache.commons.codec.binary.Hex;

import it.eng.spago.base.Constants;
import it.eng.spago.tracing.TracerSingleton;

public class DefaultCipher implements IFaceCipher {
    private Cipher _cipher = null;
    private SecretKeySpec _skeySpec = null;
    private static final String _charSkey = "a3d480d3197daf43ade4c34cb53d4c2f";

    public DefaultCipher() {
        super();
        try {
            byte[] rawSkey = Hex.decodeHex(_charSkey.toCharArray());
            _skeySpec = new SecretKeySpec(rawSkey, "AES");
            _cipher = Cipher.getInstance("AES");
        } // try 
        catch (Exception e) {
            TracerSingleton.log(
                Constants.NOME_MODULO,
                TracerSingleton.CRITICAL,
                "DefaultCipher::DefaultCipher:",
                e);
        } // catch (Exception e)
    } // public DefaultCipher()

    public static void main(String[] args) {
        if (args.length < 2) {
            System.out.println("Usage: command parameter");
            System.out.println("    command = encrypt, decrypt");
            return;
        } // if (args.length == 0)
        DefaultCipher defaultCipher = new DefaultCipher();
        if (args[0].equalsIgnoreCase("encrypt"))
            System.out.println(
                "encrypted [" + defaultCipher.encrypt(args[1]) + "]");
        else if (args[0].equalsIgnoreCase("decrypt"))
            System.out.println(
                "decrypted [" + defaultCipher.decrypt(args[1]) + "]");
        else {
            System.out.println("Usage: command parameter");
            System.out.println("    command = encrypt, decrypt");
        } // if (args[0].equalsIgnoreCase("decrypt"))
    } // public static void main(String[] args)

    public String encrypt(String charToEncrypt) {
        String encrypted = null;
        try {
            _cipher.init(Cipher.ENCRYPT_MODE, _skeySpec);
            byte[] rowToEncrypt = charToEncrypt.getBytes("utf-8");
            byte[] rowEncrypted = _cipher.doFinal(rowToEncrypt);
            char[] charEncrypted = Hex.encodeHex(rowEncrypted);
            encrypted = new String(charEncrypted);
        } // try 
        catch (Exception e) {
            TracerSingleton.log(
                Constants.NOME_MODULO,
                TracerSingleton.CRITICAL,
                "DefaultCipher::encrypt:",
                e);
        } // catch (Exception e)
        return encrypted;
    } // public String encrypt(String toEncrypt)

    public String decrypt(String charToDecrypt) {
        String decrypted = null;
        try {
            _cipher.init(Cipher.DECRYPT_MODE, _skeySpec);
            char[] charEncrypted = charToDecrypt.toCharArray();
            byte[] rowToDecrypt = Hex.decodeHex(charEncrypted);
            byte[] rowDecrypted = _cipher.doFinal(rowToDecrypt);
            decrypted = new String(rowDecrypted, "utf-8");
        } // try 
        catch (Exception e) {
            TracerSingleton.log(
                Constants.NOME_MODULO,
                TracerSingleton.CRITICAL,
                "DefaultCipher::decrypt:",
                e);
        } // catch (Exception e)
        return decrypted;
    } // public String decrypt(String toDecrypt)
} // public class DefaultCipher implements IFaceCipher
