/**

    Copyright 2004, 2006 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.security;

import it.eng.spago.base.SourceBean;
import it.eng.spago.error.EMFInternalError;

/**
 * @author zoppello
 *
 * Questa interfaccia deve essere implementa per ogni singolo meccanismo di
 * autenticazione che si intende supportare
 */
public interface IAuthenticationHandler {
    /**
    * Il nome del parametro che rappresenta lo userID in requestContainer
    */
    public static final String USER_ID_TAG = "userID";

    /**
     * Il nome del parametro che rappresenta la password in request container
     */
    public static final String PASSWORD_TAG = "password";

    /**
     * Method authenticate.
     * @param request
     * @param response
     * @return Object - Il token che identifica l'utente dopo un'autenticazione
     * avvenuta con successo
     * @throws EMFInternalError
     */
    public Object authenticate(SourceBean request, SourceBean response) throws EMFInternalError;
}
