package it.eng.spago.security;

import it.eng.spago.error.EMFInternalError;

import java.util.Collection;



 /**
 * @author Andrea Zoppello
 *
 * Define extended interface to query the user profile about a user access
 * on a particular resource
 *
 */
public interface IExtendedEngUserProfile extends IEngUserProfile {
	
	public boolean canAccessResource(String resourceID) throws EMFInternalError;
	
	public Collection getAccessibleResources() throws EMFInternalError;

	public boolean canExecuteFunctionality(String functionalityID) throws EMFInternalError;
}
