/**

    Copyright 2004, 2006 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.transcoding;

import it.eng.spago.base.SourceBean;
import it.eng.spago.error.EMFInternalError;

import javax.xml.transform.Result;
import javax.xml.transform.Templates;

/**
 * This in the interface to be implemented by XSL transcoders.
 */
public interface TranscoderIFace {

    /**
     * Perform the XSL transformation
     * @param toRender The SourceBean to render.
     * @param xslTemplate The XSL to apply
     * @param out The result of transformation
     */
    void perform(SourceBean toRender, Templates xslTemplate, Result out) throws EMFInternalError;

}
