package it.eng.spago.validation;

import it.eng.spago.base.CloneableObject;
import it.eng.spago.error.EMFErrorCategory;

import java.util.List;

public class EMFValidationError extends EMFFieldUserError {

    private static final long serialVersionUID = 1L;
        
    /**
     * Costruisce un oggetto di tipo <code>EMFValidationError</code> identificandolo  tramite  una severity e un
     * codice di errore .
     * @param severity severity dell'errore.
     * @param fieldName il nome del field che ha generato l'errore
     * @param code codice di errore.
     * @param bundle da usare per i messaggi.
     */
    public EMFValidationError(String severity, String fieldName, String code, String bundle) {
        super(severity, fieldName, code, bundle);
    } // public EMFUserError(String severity, int code)

    /**
     * Costruisce un oggetto di tipo <code>EMFValidationError</code> identificandolo  tramite  una severity e un
     * codice di errore .
     * @param severity severity dell'errore.
     * @param fieldName il nome del field che ha generato l'errore
     * @param code codice di errore.
     */
    public EMFValidationError(String severity, String fieldName, String code) {
        super(severity, fieldName, code);
    } // public EMFUserError(String severity, int code)

    /**
     * Costruisce un oggetto di tipo <code>EMFValidationError</code> identificandolo  tramite  una severity ,un
     * codice di errore e una collezione di parametri che andranno a sostituire i caratteri <em>%</em> nella
     * stringa di descrizione.
     * @param severity severity dell'errore.
     * @param code codice di errore.
     * @parma fieldName il nome del field che ha generato l'errore
     * @param params vettore di parametri che  verranno inseriti nella stringa di descrizione.
     * @param bundle da usare per i messaggi.
     */
    public EMFValidationError(String severity, String fieldName, String code, List params, String bundle) {
        super(severity, fieldName, code, params, bundle);
    } // public EMFUserError(String severity, int code, List params)

    /**
     * Costruisce un oggetto di tipo <code>EMFValidationError</code> identificandolo  tramite  una severity ,un
     * codice di errore e una collezione di parametri che andranno a sostituire i caratteri <em>%</em> nella
     * stringa di descrizione.
     * @param severity severity dell'errore.
     * @param code codice di errore.
     * @parma fieldName il nome del field che ha generato l'errore
     * @param params vettore di parametri che  verranno inseriti nella stringa di descrizione.
     */
    public EMFValidationError(String severity, String fieldName, String code, List params) {
        super(severity, fieldName, code, params);
    } // public EMFUserError(String severity, int code, List params)
    
    /**
     * Costruisce un oggetto di tipo <code>EMFUserError</code> identificandolo  tramite  una severity ,un
     * codice di errore , una collezione di parametri che andranno a sostituire i caratteri <em>%</em> nella
     * stringa di descrizione e un oggetto di qualsiasi natura.
     * @param severity severity dell'errore.
     * @param code codice di errore.
     * @param params vettore di parametri che  verranno inseriti nella stringa di descrizione.
     * @param additionalInfo oggetto di qualsiasi natura.
     * @param bundle da usare per i messaggi.
     */
    public EMFValidationError(String severity, String fieldName, String code, List params, Object additionalInfo, String bundle) {
        super(severity, fieldName, code, params, additionalInfo, bundle);
    } // public EMFUserError(String severity, int code, List params, Object additionalInfo)

    /**
     * Costruisce un oggetto di tipo <code>EMFUserError</code> identificandolo  tramite  una severity ,un
     * codice di errore , una collezione di parametri che andranno a sostituire i caratteri <em>%</em> nella
     * stringa di descrizione e un oggetto di qualsiasi natura.
     * @param severity severity dell'errore.
     * @param code codice di errore.
     * @param params vettore di parametri che  verranno inseriti nella stringa di descrizione.
     * @param additionalInfo oggetto di qualsiasi natura.
     */
    public EMFValidationError(String severity, String fieldName, String code, List params, Object additionalInfo) {
        this(severity, fieldName, code, params, additionalInfo, (String)null);
    } // public EMFUserError(String severity, int code, List params, Object additionalInfo)

    /**
     * Costruisce un oggetto di tipo <code>EMFValidationError</code> identificandolo  tramite  una severity e un
     * codice di errore .
     * @deprecated Use constructor with String error code identifier instead.
     * @param severity severity dell'errore.
     * @param fieldName il nome del field che ha generato l'errore
     * @param code codice di errore.
     */
    public EMFValidationError(String severity, String fieldName, int code) {
        super(severity, fieldName, code);
    } // public EMFUserError(String severity, int code)

	/**
     * Costruisce un oggetto di tipo <code>EMFValidationError</code> identificandolo  tramite  una severity e un
     * codice di errore .
     * @deprecated Use constructor with String error code identifier instead.
     * @param severity severity dell'errore.
     * @param code codice di errore.
     */
    public EMFValidationError(String severity, int code) {
        super(severity, code);
    } // public EMFUserError(String severity, int code)

    /**
     * Costruisce un oggetto di tipo <code>EMFValidationError</code> identificandolo  tramite  una severity ,un
     * codice di errore e una collezione di parametri che andranno a sostituire i caratteri <em>%</em> nella
     * stringa di descrizione.
     * @deprecated Use constructor with String error code identifier instead.
     * @param severity severity dell'errore.
     * @param code codice di errore.
     * @parma fieldName il nome del field che ha generato l'errore
     * @param params vettore di parametri che  verranno inseriti nella stringa di descrizione.
     */
    public EMFValidationError(String severity, String fieldName, int code, List params) {
        super(severity, fieldName, code, params);
    } // public EMFUserError(String severity, int code, List params)

    
    /**
     * Costruisce un oggetto di tipo <code>EMFValidationError</code> identificandolo  tramite  una severity ,un
     * codice di errore e una collezione di parametri che andranno a sostituire i caratteri <em>%</em> nella
     * stringa di descrizione.
     * @deprecated Use constructor with String error code identifier instead.
     * @param severity severity dell'errore.
     * @param code codice di errore.
     * @param params vettore di parametri che  verranno inseriti nella stringa di descrizione.
     */
    public EMFValidationError(String severity, int code, List params) {
        super(severity, code, params);
    } // public EMFUserError(String severity, int code, List params)
    
    /**
     * Costruisce un oggetto di tipo <code>EMFUserError</code> identificandolo  tramite  una severity ,un
     * codice di errore , una collezione di parametri che andranno a sostituire i caratteri <em>%</em> nella
     * stringa di descrizione e un oggetto di qualsiasi natura.
     * @deprecated Use constructor with String error code identifier instead.
     * @param severity severity dell'errore.
     * @param code codice di errore.
     * @param params vettore di parametri che  verranno inseriti nella stringa di descrizione.
     * @param additionalInfo oggetto di qualsiasi natura.
     */
    public EMFValidationError(String severity, int code, List params, Object additionalInfo) {
        super(severity, code, params, additionalInfo);
    } // public EMFUserError(String severity, int code, List params, Object additionalInfo)

    /**
     * Costruisce un oggetto di tipo <code>EMFValidationError</code> utilizzando lo stato del parametro
     * in input.
     * @param EMFValidationError oggetto della stessa classe.
     */
    public EMFValidationError(EMFValidationError valError) {
        super(valError);
    } // public EMFValidationError(EMFValidationError userError)

    /* (non-Javadoc)
     * @see it.eng.spago.error.EMFAbstractError#getCategory()
     */
    public String getCategory() {
        return EMFErrorCategory.VALIDATION_ERROR;
    }

    /**
     * Ritorna un clone dell'oggetto stesso.
     * @return CloneableObject  il clone dell'oggetto.
     * @see CloneableObject
     */
    public CloneableObject cloneObject() {
        return new EMFValidationError(this);
    } // public CloneableObject cloneObject()

}
