package it.eng.spago.validation;

import java.util.Map;

import it.eng.spago.base.SourceBean;

public interface FieldValidatorIFace {
	
	public void init(SourceBean config);
	
	public SourceBean getConfig();
	
    /**
     * Validate a single field.
     * @param serviceRequest Service request
     * @param fieldName Field name
     * @param value Value to validate
     * @param fieldValidationParams Configuration parameters
     * @throws EMFValidationError Validation error if the value is not valid
     */
    public void validateField(SourceBean serviceRequest, String fieldName, String value, Map fieldValidationParams) throws EMFValidationError;
    
    /**
     * Set the default value on the field, if configured
     * @param serviceRequest Service request
     * @param fieldName Field name
     * @param fieldValidationParams Configuration parameters
     * @return true if the default value was setted
     * @throws EMFValidationError
     */
    public boolean setDefault(SourceBean serviceRequest, String fieldName, Map fieldValidationParams) throws EMFValidationError;
    
}
