/**
 * 
 * Copyright 2004, 2005 Engineering Ingegneria Informatica S.p.A. & Sinapsi
 * S.p.A.
 * 
 * This file is part of Spago.
 * 
 * Spago is free software; you can redistribute it and/or modify it under the
 * terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or any later version.
 * 
 * Spago is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Spago; if not, write to the Free Software Foundation, Inc., 51
 * Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
 *  
 */
package it.eng.spago.validation;

import it.eng.spago.dispatching.service.RequestContextIFace;

public interface ValidationEngineIFace {

    /**
     * Performs the validation of the request
     * 
     * @param businessType - Type of service (action/page)
     * @param businessName - Logical name of the service
     * @param requestContainer
     * @param responseContainer
     * @return true if the process can be invoked
     */
	public boolean validate(final String businessType,
			final String businessName, RequestContextIFace requestContext);

    /**
     * @return true if the service has to be invoked even if the validation process produces errors
    */
    public boolean isBlocking();

}
