package it.eng.spago.validation.impl;

import it.eng.spago.base.SourceBean;
import it.eng.spago.base.SourceBeanException;

public class ValidationServices {

	/**
	 * The Key of the element that represent the Typed service Request
	 */
    public static final String TYPED_SERVICE_REQUEST = "TYPED_SERVICE_REQUEST";

    /**
	 * This method get the TYPED_SERVICE_REQUEST SourceBean from Service Request, if service Request doesn't have
	 * the Typed Service Request this will be created
	 * 
	 * @param serviceRequest The Spago Service Request
	 * @return The Typed Service Request Source Bean
	 * @throws SourceBeanException if some errors occurs istantiating service request source bean
	 */
	public static SourceBean getTypedServiceRequest(SourceBean serviceRequest) throws SourceBeanException{
		SourceBean typedServiceRequest  = (SourceBean)serviceRequest.getAttribute(TYPED_SERVICE_REQUEST);
		if ( typedServiceRequest == null){
			typedServiceRequest = new SourceBean(TYPED_SERVICE_REQUEST);
			serviceRequest.setAttribute(typedServiceRequest);
		}
		return typedServiceRequest;
		
	}

}
