/**

    Copyright 2004, 2006 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.dispatching.httpchannel.upload;

import it.eng.spago.dispatching.service.DefaultRequestContext;

import org.apache.commons.fileupload.FileItem;

public class SaveAsAttributeUploader extends DefaultRequestContext implements IUploadHandler {

	private static final long serialVersionUID = 1L;

	public void upload(FileItem fileItem) throws Exception {
		String fieldName = fileItem.getFieldName();
		String fileName = fileItem.getName();

		byte[] data = fileItem.get();
		getServiceRequest().setAttribute(
				fieldName + "_FILENAME", fileName);
		getServiceRequest().setAttribute(
				fieldName + "_FILEDATA", data);
	}

}
