/**

    Copyright 2004, 2006 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.dispatching.module;

import it.eng.spago.base.Constants;
import it.eng.spago.base.SourceBean;
import it.eng.spago.dispatching.service.HttpServiceIFace;
import it.eng.spago.dispatching.service.list.basic.IFaceBasicListService;
import it.eng.spago.dispatching.service.list.basic.impl.DelegatedBasicListService;
import it.eng.spago.paginator.basic.ListIFace;
import it.eng.spago.tracing.TracerSingleton;

public abstract class AbstractHttpListModule extends AbstractHttpModule implements HttpServiceIFace, IFaceBasicListService {
    private ListIFace _list = null;

    public AbstractHttpListModule() {
        super();
    } // public AbstractHttpListModule()

    public void init(SourceBean config) {
        super.init(config);
        _list = null;
    } // public void init(SourceBean config)

    public ListIFace getList() {
        return _list;
    } // public ListIFace getList()

    public void setList(ListIFace list) {
        _list = list;
    } // public void setList(ListIFace list)

    public void service(SourceBean request, SourceBean response) throws Exception {
        DelegatedBasicListService.service(this, request, response);
    } // public void service(SourceBean request, SourceBean response) throws Exception

    public abstract ListIFace getList(SourceBean request);

    public void callback(SourceBean request, ListIFace list, int page) {
        TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.DEBUG,
            "AbstractHttpListModule::callback: non implementato");
    } // public void callback(SourceBean request, ListIFace list, int page)

    public void delete(SourceBean request) {
        TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.DEBUG, "AbstractHttpListModule::delete: non implementato");
    } // public void delete(SourceBean request)
} // public abstract class AbstractHttpListModule extends AbstractHttpModule implements HttpServiceIFace
