/**

    Copyright 2004, 2006 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.dispatching.module;

import it.eng.spago.base.SourceBean;
import it.eng.spago.dispatching.service.DefaultHttpRequestContext;
import it.eng.spago.init.InitializerIFace;

public abstract class AbstractHttpModule extends DefaultHttpRequestContext implements InitializerIFace, ModuleIFace {
    private SourceBean _config = null;
    private String _module = null;
    private String _page = null;
    private SourceBean _sharedData = null;

    public AbstractHttpModule() {
        super();
        _config = null;
        _module = null;
        _page = null;
        _sharedData = null;
    } // public AbstractHttpModule()

    public void init(SourceBean config) {
        _config = config;
    } // public void init(SourceBean config)

    public SourceBean getConfig() {
        return _config;
    } // public SourceBean getConfig()

    public String getModule() {
        return _module;
    } // public String getModule()

    public void setModule(String module) {
        _module = module;
    } // public void setModule(String module)

    public String getPage() {
        return _page;
    } //public String getPage()

    public void setPage(String page) {
        _page = page;
    } //public void setMessage(String message)

    public SourceBean getSharedData() {
        return _sharedData;
    } //public SourceBean getSharedData()

    public void setSharedData(SourceBean sharedData) {
        _sharedData = sharedData;
    } //public SourceBean getSharedData(SourceBean sharedData)
} // public abstract class AbstractHttpModule extends
// DefaultHttpRequestContext implements InitializerIFace, ModuleIFace
