/**

    Copyright 2004, 2006 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.tags;

import java.util.List;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.TagSupport;

import it.eng.spago.base.Constants;
import it.eng.spago.base.SourceBean;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.tracing.TracerSingleton;

/**
* DATE            CONTRIBUTOR/DEVELOPER    NOTE
* 13-12-2004		  Butano           SOurceBean restituisce ArrayList
* 										    
**/

/**
 * @author 
 */
public class DefaultLookupClientTag extends TagSupport {
    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    protected String _idlookup = null;
    protected StringBuffer _htmlStream = null;

    public DefaultLookupClientTag() {
        super();
    }

    public int doStartTag() throws JspException {
        TracerSingleton.log(
            Constants.NOME_MODULO,
            TracerSingleton.INFORMATION,
            "DefaultLookupClientTag::doStartTag:: invocato");
        JspWriter out = pageContext.getOut();
        _htmlStream = new StringBuffer();
        // costruzione  sezione FORM
        makeJavaScript();
        try {
            out.print(_htmlStream);
        } // try
        catch (Exception ex) {
            TracerSingleton.log(
                Constants.NOME_MODULO,
                TracerSingleton.CRITICAL,
                "DefaultLookupClientTag::doStartTag:: Impossibile inviare lo stream");
            throw new JspException("Impossibile inviare lo stream");
        } // catch (Exception ex)
        return SKIP_BODY;
    } // public int doStartTag() throws JspException

    protected void makeJavaScript() throws JspException {
        ConfigSingleton configure = ConfigSingleton.getInstance();
        SourceBean lookup =
            (SourceBean) configure.getFilteredSourceBeanAttribute(
                "LOOKUPS.LOOKUP",
                "idlookup",
                _idlookup);
        if (lookup == null) {
            TracerSingleton.log(
                Constants.NOME_MODULO,
                TracerSingleton.MAJOR,
                "DefaultLookupClientTag::makeJavaScript:: La definizione del lookup "
                    + _idlookup
                    + " non  censita nel file xml. ");
            throw new JspException(
                "La definizione del lookup "
                    + _idlookup
                    + " non  censita nel file xml. ");
        } //if (lookupPage == null){
        String formName = (String) lookup.getAttribute("PARAMETERS.formName");
        if (formName == null) {
            TracerSingleton.log(
                Constants.NOME_MODULO,
                TracerSingleton.MAJOR,
                "DefaultLookupClientTag::makeJavaScript:: Non  stato specificato nessun formName");
            throw new JspException("Non  stato specificato nessun formName");
        } //if (formName == null){
        String pageName = (String) lookup.getAttribute("PARAMETERS.pageName");
        if (pageName == null) {
            TracerSingleton.log(
                Constants.NOME_MODULO,
                TracerSingleton.MAJOR,
                "DefaultLookupClientTag::makeJavaScript:: Non  stato specificato nessun pageName");
            throw new JspException("Non  stato specificato nessun pageName");
        } //if (pageName == null){
        String moduleName =
            (String) lookup.getAttribute("PARAMETERS.moduleName");
        if (moduleName == null) {
            TracerSingleton.log(
                Constants.NOME_MODULO,
                TracerSingleton.MAJOR,
                "DefaultLookupClientTag::makeJavaScript:: Non  stato specificato nessun moduleName");
            throw new JspException("Non  stato specificato nessun moduleName");
        } //if (moduleName == null){
        StringBuffer fieldsBuffer = new StringBuffer("");
        List fields = lookup.getAttributeAsList("PARAMETERS.FIELDS.FIELD");
        for (int i = 0; i < fields.size(); i++) {
            SourceBean field = (SourceBean) fields.get(i);
            String formField = (String) field.getAttribute("formField");
            String likeField = (String) field.getAttribute("likeField");
            fieldsBuffer.append("    _url = _url + '" + formField + "=' +");
            fieldsBuffer.append(
                "escape(Trim(document."
                    + formName
                    + "."
                    + formField
                    + ".value)");
            if (likeField != null && likeField.equalsIgnoreCase("true")) {
                fieldsBuffer.append(" + '%' ");
            } //if (likeField != null && likeField.equalsIgnoreCase("true") ) {
            fieldsBuffer.append(" )+'&';\n");
        } //for (int i=0;i<fields.size();i++){
        StringBuffer strURL = new StringBuffer("");
        strURL.append("PAGE=" + pageName);
        strURL.append("&module=" + moduleName);
        strURL.append("&idlookup=" + _idlookup);
        strURL.append("&list_nocache=TRUE");
        strURL.append("&NAVIGATOR_DISABLED=TRUE&");
        _htmlStream.append(
            "<SCRIPT language=\"Javascript\" type=\"text/javascript\"> \n");
        _htmlStream.append("function lookup_" + _idlookup + "() { \n");
        _htmlStream.append("   var _url = 'AdapterHTTP?'; \n");
        _htmlStream.append("   _url = _url + '" + strURL + "' \n");
        _htmlStream.append(fieldsBuffer);
        _htmlStream.append(
            "  var modalWindow = window.open(_url,'ModalChild','dependent=yes,help=no,status=no,resizable=yes');\n");
        _htmlStream.append("  modalWindow.focus() \n");
        _htmlStream.append("} \n");
        _htmlStream.append("</SCRIPT> \n");
    } // protected void makeJavaScript()

    public void setIdLookup(String idlookup) {
        TracerSingleton.log(
            Constants.NOME_MODULO,
            TracerSingleton.INFORMATION,
            "DefaultLookupClientTag::setIdLookup:: idLookup ["
                + idlookup
                + "]");
        _idlookup = idlookup;
    } // public void setIdLookup(String idlookup) {
} //public class DefaultLookupClientTag extends TagSupport {
